题目链接:https://leetcode.com/problems/sliding-window-maximum/

题目:
Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

For example,
Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.

Window position Max
————— —–
[1 3 -1] -3 5 3 6 7 3
1 [3 -1 -3] 5 3 6 7 3
1 3 [-1 -3 5] 3 6 7 5
1 3 -1 [-3 5 3] 6 7 5
1 3 -1 -3 [5 3 6] 7 6
1 3 -1 -3 5 [3 6 7] 7
Therefore, return the max sliding window as [3,3,5,5,6,7].

Note:
You may assume k is always valid, ie: 1 ≤ k ≤ input array’s size for non-empty array.

Follow up:
Could you solve it in linear time?

思路:
果然是hard啊。。想做O(N)的解法没想出来,看了网上的思路,结果发现。。也是O(n*k)的。。。坑爹么。。

算法:

public int[] maxSlidingWindow(int[] nums, int k) {
          if(k==0)
            return new int[0];
        int res[] = new int[nums.length - k + 1];

        LinkedList<Integer> idxs = new LinkedList<Integer>();

        for (int i = 0; i < nums.length; i++) {
            while (!idxs.isEmpty() && nums[i] >=nums[idxs.getLast()]) { // 删除窗口内小于将入元素i 的所有元素
                idxs.removeLast();// 因为i是窗口内最新的元素,比它小的元素肯定比它早踢出窗口
            }
            idxs.addLast(i);

            if (i - idxs.getFirst() + 1 > k) { 
                idxs.removeFirst();
            }
            if (i + 1 >= k)
                res[i-k+1] = nums[idxs.getFirst()];
        }
        return res;
    }